<?php
//------------------- Генерация -------------------//
$genn=microtime(1);
//------------------- PDO -------------------//
define ('DBHOST', 'localhost');
define ('DBPORT', '3306');
define ('DBNAME', 'z'); //база
define ('DBUSER', 'root'); //пользователь
define ('DBPASS', ''); //пароль

@ini_set('url_rewriter.tags', '');
@ini_set('session.use_trans_sid', 1);
@ini_set('session.use_only_cookies', 0);

ob_start();
ob_implicit_flush(0);
session_start();


$starttime = microtime(1);
$ip = preg_replace('|[^0-9\.]|', '', $_SERVER['REMOTE_ADDR']);
if (version_compare(PHP_VERSION, '5.2.1') < 0) {
	die('<b>Ошибка! Версия PHP должна быть 5.2.1 или выше!</b>');
} 

if (get_magic_quotes_gpc()) {
	$in = array(&$_GET, &$_POST, &$_COOKIE);
	while (list($k, $v) = each($in)) {
		foreach ($v as $key => $val) {
			if (!is_array($val)) {
				$in[$k][$key] = stripslashes($val);
				continue;
			} 
			$in[] = &$in[$k][$key];
		} 
	} 
	unset ($in);
	if (!empty ($_FILES)) {
		foreach ($_FILES as $k => $v) {
			$_FILES[$k]['name'] = stripslashes((string) $v['name']);
		} 
	} 
} 


// ---------------------------- Класс для работы с базами данных -------------------------------//
class PDO_ extends PDO {
	static $counter = 0;

	function __construct($dsn, $username, $password) {
		parent::__construct($dsn, $username, $password);
		$this -> setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
		$this -> setAttribute(PDO::ATTR_DEFAULT_FETCH_MODE, PDO::FETCH_ASSOC);
		$this -> setAttribute(PDO::MYSQL_ATTR_USE_BUFFERED_QUERY, true);
	} 

	function prepare($sql, $params = array()) {
		$stmt = parent::prepare($sql, array(
				PDO::ATTR_STATEMENT_CLASS => array('PDOStatement_')
				));
		return $stmt;
	} 

	function query($sql, $params = array()) {
		self::$counter++;
		$stmt = $this -> prepare($sql);
		$stmt -> execute($params);
		return $stmt;
	} 

	function querySingle($sql, $params = array()) {
		$stmt = $this -> query($sql, $params);
		return $stmt -> fetchColumn(0);
	} 
	
		function queryNum($sql, $params = array()) {
		$stmt = $this -> query($sql, $params);
		return $stmt -> rowCount(0);
	} 

	function queryFetch($sql, $params = array()) {
		$stmt = $this -> query($sql, $params);
		return $stmt -> fetch();
	} 

	function queryCounter() {
		return self::$counter;
	} 
} 
// ----------------------------------------------------//
class PDOStatement_ extends PDOStatement {
	function execute($params = array()) {
		if (func_num_args() == 1) {
			$params = func_get_arg(0);
		} else {
			$params = func_get_args();
		} 
		if (!is_array($params)) {
			$params = array($params);
		} 
		parent::execute($params);
		return $this;
	} 

	function fetchSingle() {
		return $this -> fetchColumn(0);
	} 

	function fetchAssoc() {
		$this -> setFetchMode(PDO::FETCH_NUM);
		$data = array();
		while ($row = $this -> fetch()) {
			$data[$row[0]] = $row[1];
		} 
		return $data;
	} 
} 


// --------------- Класс singleton для подключения к БД -----------------//
class DB {
	private static $instance;
	private function __construct() {} 
	private function __clone() {}
	
	public static function run() {
		
		if (!isset(self::$instance)) {
		
			try {
				self::$instance = new PDO_('mysql:host='.DBHOST.';port='.DBPORT.';dbname='.DBNAME, DBUSER, DBPASS);
				self::$instance -> exec('SET CHARACTER SET utf8');
				self::$instance -> exec('SET NAMES utf8');
			} 
			
			catch (PDOException $e) {
		      if (file_exists('/install/index.php')) {
		        header ('Location: /install/index.php');
		        exit;
		      } 
				die('Нет соединения с БД');
			} 
		}
		return self::$instance;	
	}

	final public function __destruct() {
		self::$instance = null;
	} 

} 



?>